#include <stdlib.h>
#include <dir.h>
#include <direct.h>
#include <dos.h>
#include <string.h>
#include "globals.h"

int cleanpath(char *Working) {

	char drive[_MAX_DRIVE], dir[_MAX_DIR], name[_MAX_FNAME], ext[_MAX_EXT];
	char tpath[_MAX_PATH];
	int cdrive = _getdrive();
	unsigned i, pdrive, c;

	if (_fullpath(tpath,Working,_MAX_PATH) == NULL) return(-4);

	_splitpath(tpath,drive,dir,name,ext);

	if (((char)cdrive + 'A' - '\1') != drive[0]) {
		if ((_chdrive((int)(drive[0] - 'A' + '\1'))) !=0)
			return(-6);
		else {
			_chdrive(cdrive);
		}
	}

	if (name[0] == '\0') {
		name[0] = '*';
		name[1] = '\0';
		if (ext[0] == '\0') {
			ext[0] = '.';
			ext[1]= '*';
			ext[2] = '\0';
		}
	}

	_makepath(Working,drive,dir,"","");

	i = 0;
	do ++i; while (Working[i] != '\0');
	if (i > 3) {
		if (Working[i - 1] == '\\')  Working[--i] = '\0';
		if ((findfirst(Working, &Entrie, _A_SUBDIR)) != 0) return(-5);
	}

	if (Working[i - 1] != '\\') Working[i++] = '\\';
	pdrive = 0;
	while ((name[pdrive] != '\0') && (i < _MAX_PATH)) Working[i++] = name[pdrive++];
	if (i == _MAX_PATH) return(-9);
	pdrive = 0;
	while ((ext[pdrive] != '\0') && (i < _MAX_PATH )) Working[i++] = ext[pdrive++];
	if (i == _MAX_PATH) return(-9);
	Working[i] = '\0';

	if ((i + 4) >= _MAX_PATH) return(0);
	c = 0;
	while (Working[c] != '\0') if ((Working[c] == '*') || (Working[c] == '?')) return(0); else ++c;

	if (findfirst(tpath, &Entrie, 0xFF)) return(0);

	if (!(Entrie.ff_attrib & _A_SUBDIR)) return(0);

	if (Working[i - 1] != '\\') Working[i++] = '\\';
	Working[i++] = '*';
	Working[i++] = '.';
	Working[i++] = '*';
	Working[i] = '\0';


	return(0);
}

int getdirinfo(void) {

	unsigned i = 0, flag = 0;
	int c = 0;
	unsigned long x = 0;
	unsigned long DriveBytes = 0, FreeBytes = 0, TotalBytes = 0, UsedBytes = 0;
	unsigned DBOverflow = 0, FBOverflow = 0, TBOverflow = 0, UBOverflow = 0, BlockSize = 0;
	char rootp[7] = "", filter = '\0';
	char const uflow[7] = "< 1 KB";
	diskfree_t Free;

	for (i = 0; i < 3; i++)
		rootp[i] = DInfo.Path[i];
	rootp[i++] = '*';
	rootp[i++] = '.';
	rootp[i++] = '*';
	rootp[i] = '\0';

	_dos_getdiskfree(DInfo.Path[0] - 'A' + 1, &Free);

	BlockSize = Free.sectors_per_cluster * Free.bytes_per_sector;

	for (i = 0; i < BlockSize; i ++) {
		DriveBytes += Free.total_clusters;
		if (DriveBytes < Free.total_clusters) ++DBOverflow;
		FreeBytes += Free.avail_clusters;
		if (FreeBytes < Free.avail_clusters) ++FBOverflow;
	}

	i = findfirst(rootp, &Entrie, _A_LABEL);
	if(!i && (Entrie.ff_attrib & _A_LABEL)) {
		x = 0;
		c = 0;
		flag = 0;
		while ((Entrie.ff_name[flag] != '\0') && (Entrie.ff_name[flag] != '.')) ++flag;
		if (Entrie.ff_name[flag] == '\0') {
			while ((Entrie.ff_name[x] != 0) && (x < (_MAX_LABEL - 1)))
				DInfo.DLabel[x] = Entrie.ff_name[x++];
			DInfo.DLabel[x] = '\0';
		} else {
			for (c = 0; c < flag; c++)
				DInfo.DLabel[x++] = Entrie.ff_name[c];
			while ((Entrie.ff_name[++c] != '\0') && (x < (_MAX_LABEL - 1)))
				DInfo.DLabel[x++] = Entrie.ff_name[c];
			DInfo.DLabel[x] = '\0';
		}
		DInfo.LLen = x;
	} else {DInfo.DLabel[0] = '\0';DInfo.LLen = 0;}

	DInfo.TFiles = 0;
	DInfo.TDirectories = 0;

	if ((bgiven.dplace & 3) == 3) filter = ~(_A_LABEL | _A_SUBDIR);
		else filter = ~(_A_LABEL);

	i = findfirst(DInfo.Path, &Entrie, filter);
	while (!i) {
		x = Entrie.ff_fsize / BlockSize;
		if ((Entrie.ff_fsize % BlockSize) != 0) ++x;
		UsedBytes += (x * BlockSize);
		if (UsedBytes < (x * BlockSize)) ++UBOverflow;
		TotalBytes += Entrie.ff_fsize;
		if (TotalBytes < Entrie.ff_fsize) ++TBOverflow;
		if (Entrie.ff_attrib & _A_SUBDIR) {
			++DInfo.TDirectories;
			if (DInfo.TDirectories == 0) return(-7);
		} else {
			++DInfo.TFiles;
			if (DInfo.TFiles == 0) return(-7);
		}
	i = findnext(&Entrie);
	}

	if (tscreen.columns < 40) {
		if ((DBOverflow == 0) && (DriveBytes < 1000)) for (c = 0; c < 7; c++) DInfo.DriveSize[c] = uflow[c];
		else textval(DInfo.DriveSize,DBOverflow,DriveBytes,6);
		if ((FBOverflow == 0) && (FreeBytes < 1000)) for (c = 0; c < 7; c++) DInfo.DriveFree[c] = uflow[c];
		else textval(DInfo.DriveFree,FBOverflow,FreeBytes,6);
	} else {
		textval(DInfo.DriveSize,DBOverflow,DriveBytes,9);
		textval(DInfo.DriveFree,FBOverflow,FreeBytes,9);
	}

	if (tscreen.columns < 60) {
		if ((TBOverflow == 0) && (TotalBytes < 1000)) for (c = 0; c < 7; c++) DInfo.TBytes[c] = uflow[c];
		else textval(DInfo.TBytes,TBOverflow,TotalBytes,6);
		if ((UBOverflow == 0) && (UsedBytes < 1000)) for (c = 0; c < 7; c++) DInfo.UBytes[c] = uflow[c];
		else textval(DInfo.UBytes,UBOverflow,UsedBytes,6);
	} else {
		textval(DInfo.TBytes,TBOverflow,TotalBytes,9);
		textval(DInfo.UBytes,UBOverflow,UsedBytes,9);
	}


	return(0);
}

int getlist(void) {

	unsigned i = 0, c = 0, x = 0, m = 0;
	unsigned char filter = '\0';

	if ((bgiven.dplace & 3) == 3) filter = ~(_A_LABEL | _A_SUBDIR);
		else filter = ~(_A_LABEL);

	i = findfirst(DInfo.Path,&Entrie,filter);
	while (!i) {
		if (c == TList) return(-8);
		flist[c].attrib = Entrie.ff_attrib;
		flist[c].size = Entrie.ff_fsize;
		flist[c].date = Entrie.ff_fdate;
		flist[c].time = Entrie.ff_ftime;

		x = 0;
		if ((Entrie.ff_name[0] == '.') && (Entrie.ff_name[1] == '\0')) {
			while (Entrie.ff_name[x] != '\0') flist[c].name[x] = Entrie.ff_name[x++];
			flist[c].name[x] = '\0';
			flist[c].ext[0] = '\0';
		} else if ((Entrie.ff_name[0] == '.') && (Entrie.ff_name[1] == '.') && (Entrie.ff_name[2] == '\0')) {
			while (Entrie.ff_name[x] != '\0') flist[c].name[x] = Entrie.ff_name[x++];
			flist[c].name[x] = '\0';
			flist[c].ext[0] = '\0';
		} else {
			m = 0;
			while ((Entrie.ff_name[x] != '.') && (Entrie.ff_name[x] != '\0'))
				flist[c].name[x] = Entrie.ff_name[x++];
			flist[c].name[x] = '\0';
			if (Entrie.ff_name[x] != '\0') ++x;
			while (Entrie.ff_name[x] != '\0') flist[c].ext[m++] = Entrie.ff_name[x++];
			flist[c].ext[m] = '\0';
		}
		++c;
		i = findnext(&Entrie);
	}

	return(0);
}

